//----------------------------------------------------------------------------
//
//		This file is part of the FALCON II.
//
//		The FALCON II is free software: you can redistribute it and/or modify
//		it under the terms of the GNU General Public License as published by
//		the Free Software Foundation, either version 3 of the License, or
//		(at your option) any later version.
//
//		The FALCON II is distributed in the hope that it will be useful,
//		but WITHOUT ANY WARRANTY; without even the implied warranty of
//		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//		GNU General Public License for more details.
//
//		You should have received a copy of the GNU General Public License
//		along with the FALCON II.  If not, see http://www.gnu.org/licenses/.
//
//		The FALCON II is copyright 2008-2009 by Timothy Pearson
//		tpearson@raptorengineeringinc.com
//		http://www.raptorengineeringinc.com
//
//----------------------------------------------------------------------------
//
//		The FALCON II is available as a reference design for the 
//		Raptor Engineering VDFPGA series of FPGA development boards
//		Please visit http://www.raptorengineeringinc.com for more information.
//
//----------------------------------------------------------------------------

#include <stdio.h>                /* perror() */
#include <stdlib.h>               /* atoi() */
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>               /* read() */
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h>

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "main.h"
#include "gtk_image_auxfunctions.h"

unsigned int rx_buffer_count;
int clientSocket, remotePort, status = 0;
int last_command_acked = 0;
int data_goahead = 0;
struct hostent *hostPtr = NULL;
struct sockaddr_in serverName = { 0 };
char buffer[2457600] = "";
char *remoteHost = NULL;
extern char imagemagick_found;

extern char LoginOKClicked;
extern char LoginCancelClicked;

char temp_buffer[2457600];
char temp_buffer2[1024];
unsigned int recd_number_array[512];
int i;
int j;
int k;
int x;
int y;

int execute_connection_alive_timer;
int disable_connection_alive_timer;
int connection_alive_timer;
int connection_irrecoverable_timer;

int authenticated;

unsigned char terminate_now = 0;

int authentication_failed_timer;
int connection_failed_timer;

int connection_timer_check(void);

unsigned char ip_q1;
unsigned char ip_q2;
unsigned char ip_q3;
unsigned char ip_q4;

unsigned char nm_q1;
unsigned char nm_q2;
unsigned char nm_q3;
unsigned char nm_q4;

unsigned char gw_q1;
unsigned char gw_q2;
unsigned char gw_q3;
unsigned char gw_q4;

unsigned char sending_frame = 0;
unsigned char frame_requested = 0;
unsigned char frame_requested_request = 0;

unsigned char want_to_grab_something[5];

extern GtkWidget *dialog, *label, *okay_button, *loginname, *passentry, *label2;
extern GtkWidget *loginwindow;
extern GtkWidget *ipchangewindow;

extern GdkPixbuf *imagebuffer;
extern GdkPixbuf *hiddenbuffer;

extern char main_commands_status;

GtkWidget *currentwidget;

// reverse:  reverse string s in place
void reverse(char s[])
{
    int c, i, j;

    for (i = 0, j = strlen(s)-1; i<j; i++, j--) {
        c = s[i];
        s[i] = s[j];
        s[j] = c;
    }
}

// itoa:  convert n to characters in s
void itoa(unsigned int n, char s[])
{
    int i, sign;

    if ((sign = n) < 0)  		// record sign
        n = -n;				// make n positive
    i = 0;
    do {				// generate digits in reverse order
        s[i++] = n % 10 + '0';		// get next digit
    } while ((n /= 10) > 0);		// delete it
    if (sign < 0)
        s[i++] = '-';
    s[i] = '\0';
    reverse(s);
}

void EnableMainCommands() {
  GtkWidget *nmonitor;
  nmonitor = lookup_widget (main_window, "changeip");
  gtk_widget_set_sensitive(nmonitor, 1);
  if (imagemagick_found == 1) {
	nmonitor = lookup_widget (main_window, "loadmodel");
  }
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "setrgb");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "setycrcb");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "startrecognition");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "stoprecognition");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "sendcommand");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "getframe");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "getframebutton");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "getdctsresultsbutton");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_zero");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_one");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_two");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_custom");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "text_value");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "servername");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_zero");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_one");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_two");
  gtk_widget_set_sensitive(nmonitor, 1);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_custom");
  gtk_widget_set_sensitive(nmonitor, 1);
  main_commands_status = 1;
}

void DisableMainCommands() {
  GtkWidget *nmonitor;
  nmonitor = lookup_widget (main_window, "changeip");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "loadmodel");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "setrgb");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "setycrcb");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "startrecognition");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "stoprecognition");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "sendcommand");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "getframe");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "getframebutton");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "getdctsresultsbutton");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_zero");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_one");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_two");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "l_switchbuffer_custom");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_zero");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_one");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_two");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "r_switchbuffer_custom");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "text_value");
  gtk_widget_set_sensitive(nmonitor, 0);
  nmonitor = lookup_widget (main_window, "servername");
  gtk_widget_set_sensitive(nmonitor, 1);
  main_commands_status = 0;
}

char* start_connection(void) {
    char *currerror;

    int optval;
    int optlen;
    int sock_buf_size;

    currerror = "";

    //remoteHost = "192.168.1.200";
    GtkWidget *servername;
    servername = lookup_widget (main_window, "servername");
    remoteHost = gtk_entry_get_text(GTK_ENTRY(servername));
    remotePort = 7;

    clientSocket = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP);
    if (-1 == clientSocket)
    {
	currerror="socket()";
	goto connerr;
    }

    status = getsockopt(clientSocket, SOL_SOCKET, SO_SNDBUF, (char *)&sock_buf_size, sizeof(sock_buf_size));
    //printf("Original SO_SNDBUF size was %d\n\r", sock_buf_size);

    // Fix transmit buffer size
    sock_buf_size = 1228800;
    status = setsockopt(clientSocket, SOL_SOCKET, SO_SNDBUF, (char *)&sock_buf_size, sizeof(sock_buf_size));

    status = getsockopt(clientSocket, SOL_SOCKET, SO_SNDBUF, (char *)&sock_buf_size, sizeof(sock_buf_size));
    //printf("New SO_SNDBUF size is %d\n\r", sock_buf_size);

    // Resolve the remote server name or IP address
    hostPtr = gethostbyname(remoteHost);
    if (NULL == hostPtr)
    {
        hostPtr = gethostbyaddr(remoteHost, strlen(remoteHost), AF_INET);
        if (NULL == hostPtr)
        {
	currerror="Error resolving server address";
	goto connerr;
        }
    }

    serverName.sin_family = AF_INET;
    serverName.sin_port = htons(remotePort);
    (void) memcpy(&serverName.sin_addr, hostPtr->h_addr, hostPtr->h_length);

    status = connect(clientSocket, (struct sockaddr*) &serverName, sizeof(serverName));
    if (-1 == status)
    {
	currerror="Connection to server failed [Server Unreachable]";
	goto connerr;
    }

    status = fcntl(clientSocket, F_SETFL, O_NONBLOCK);
    if (-1 == status)
    {
	currerror="fcntl()";
	goto connerr;
    }

    write(clientSocket, "AT\n\r", 4);		// Ask if authentication needed--0 is no, anything else is the random number

    // Make sure the board actually responds...
    execute_connection_alive_timer = 1;
    connection_alive_timer = 0;
    authenticated = 0;
    authentication_failed_timer = 0;
    g_timeout_add_full (G_PRIORITY_HIGH, 10, (GSourceFunc) connection_timer_check, NULL, NULL);

    while (read(clientSocket, buffer, sizeof(buffer) - 1) == -1) {
	// Do nothing!
	gtk_main_iteration();
	if (authentication_failed_timer == 1) {
		write(clientSocket, "AT\n\r", 4);
		authentication_failed_timer++;
	}
	if (authentication_failed_timer > 4) {
		// Hmmm...four seconds has gone by with no response from the board...
		authenticated = 0;
		currerror="No authentication response!";
		goto connerr;
	}
    }
    i=atoi(buffer);
    if (i==0) {
    	authenticated = 1;
    }
    else {
	// Show a login dialog
	LoginOKClicked=0;
	LoginCancelClicked=0;
	loginwindow = create_login_window ();
	gtk_window_set_modal(GTK_WINDOW(loginwindow), TRUE);
	gtk_window_set_transient_for(GTK_WINDOW(loginwindow),GTK_WINDOW(main_window));
	gtk_widget_show (loginwindow);
	while ((LoginOKClicked==0)&&(LoginCancelClicked==0)) {
		gtk_main_iteration();
	}
	gtk_object_destroy(loginwindow);
	if (LoginCancelClicked==1) {
		currerror="Cancelled";
		goto connerr;
	}
	// End showing a login dialog
    }

    write(clientSocket, "ID\n\r", 4);		// Ask for board ID...
    last_command_acked = 0;

connerr:
    return currerror;
}

int receive_data(void) {
    GtkWidget *statuslabel;
    GtkWidget *imagebox;

    if (frame_requested == 0) {
	status = read(clientSocket, buffer, sizeof(buffer) - 1);
	if (sending_frame == 0) {
		currentwidget = lookup_widget (main_window, "transfer_progress");
		gtk_progress_configure(currentwidget,0,0,634880);
	}
    }
    else {
NotForMe:
	status = read(clientSocket, buffer, sizeof(buffer) - 1);
	if (status != -1) {
		memcpy(temp_buffer+rx_buffer_count, buffer, status);
		rx_buffer_count = rx_buffer_count + status;
		//printf("rx_buffer_count: %d status: %d frame_requested: %d\n\r", rx_buffer_count, status, frame_requested);
		if (((frame_requested == 1) && (rx_buffer_count < 1228800)) || ((frame_requested == 2) && (rx_buffer_count < 614400))) {		// 480 and 245 lines respectively
			// Apparently the FALCON didn't send all the data yet
			// No problem, just don't execute the parser at this time
			currentwidget = lookup_widget (main_window, "transfer_progress");
			if (frame_requested == 1) {
				gtk_progress_configure(currentwidget,rx_buffer_count,0,1228800);
			}
			if (frame_requested == 2) {
				gtk_progress_configure(currentwidget,rx_buffer_count,0,614400);
			}
			status = -1;
		}
	}
    }

    if (status != -1) {
	connection_failed_timer = 0;
	connection_irrecoverable_timer = 0;
	rx_buffer_count = 0;

	if (frame_requested == 0) {
		last_command_acked = 1;
		statuslabel = lookup_widget (main_window, "statuslabel");
	
		i=0;
		k=0;
MoreData01:
		j=0;
		while ((buffer[i] != '|') && (buffer[i] != 0)) {
			temp_buffer[j]=buffer[i];
			i++;
			j++;
		}
		temp_buffer[j]=0;
		recd_number_array[k]=atoi(temp_buffer);
		k++;
		if (buffer[i] == 0) {
			goto ParsingDone01;
		}
		i++;
		goto MoreData01;
ParsingDone01:
	
		gtk_label_set_text (statuslabel, buffer);
	
		if (recd_number_array[0]==1) {		// "Main status" frame received
			currentwidget = lookup_widget (main_window, "stat_f1");
			itoa(recd_number_array[1], temp_buffer);
			gtk_label_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (main_window, "stat_w1");
			itoa(recd_number_array[2], temp_buffer);
			gtk_label_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (main_window, "stat_stab");
			itoa(recd_number_array[3], temp_buffer);
			gtk_label_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (main_window, "stat_nmod");
			itoa(recd_number_array[4], temp_buffer);
			gtk_label_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (main_window, "stat_ver");
		
			currentwidget = lookup_widget (main_window, "framerate_progress");
			gtk_progress_configure(currentwidget, recd_number_array[6],0,100);	// Framerate
		}
		if (recd_number_array[0]==2) {		// "Main status and tracking results" frame received
			currentwidget = lookup_widget (main_window, "stat_ver");
			itoa(recd_number_array[1], temp_buffer);	// Version major
			itoa(recd_number_array[2], temp_buffer2);	// Version minor1
			strcat (temp_buffer, ".");
			strcat (temp_buffer, temp_buffer2);
			itoa(recd_number_array[3], temp_buffer2);	// Version minor2
			strcat (temp_buffer, temp_buffer2);
			gtk_label_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (main_window, "stat_nmod");
			itoa(recd_number_array[4], temp_buffer);	// Current number of models
			gtk_label_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (main_window, "stat_f1");
			itoa(recd_number_array[5], temp_buffer);	// System mode
			if (recd_number_array[5] == 1) gtk_label_set_text (currentwidget, "Idle");
			if (recd_number_array[5] == 2) gtk_label_set_text (currentwidget, "Slow recognition");
			if (recd_number_array[5] == 3) gtk_label_set_text (currentwidget, "Model Load");
			if (recd_number_array[5] == 4) gtk_label_set_text (currentwidget, "Fast recognition");
			if (recd_number_array[5] == 5) gtk_label_set_text (currentwidget, "Network recognition");
			currentwidget = lookup_widget (main_window, "stat_stab");
			gtk_label_set_text (currentwidget, "Unknown");
			currentwidget = lookup_widget (main_window, "stat_w1");
			sprintf(temp_buffer, "%.01f FPS", recd_number_array[6]/10.0);	// Framerate1
			gtk_label_set_text (currentwidget, temp_buffer);

			currentwidget = lookup_widget (main_window, "framerate_progress");
			gtk_progress_configure(currentwidget, recd_number_array[6],0,100);	// Framerate

			if ((recd_number_array[5] == 1) && (main_commands_status == 1)) {
				currentwidget = lookup_widget (main_window, "loadmodel");
  				gtk_widget_set_sensitive(currentwidget, 1);
				currentwidget = lookup_widget (main_window, "changeip");
  				gtk_widget_set_sensitive(currentwidget, 1);
			}
			else {
				currentwidget = lookup_widget (main_window, "loadmodel");
				gtk_widget_set_sensitive(currentwidget, 0);
				currentwidget = lookup_widget (main_window, "changeip");
  				gtk_widget_set_sensitive(currentwidget, 0);
			}
		}
	
		if (recd_number_array[0]==3) {		// IP quad frame received
			ip_q1 = buffer[2];
			ip_q2 = buffer[3];
			ip_q3 = buffer[4];
			ip_q4 = buffer[5];
			currentwidget = lookup_widget (ipchangewindow, "ip_dotquad_1");
			itoa(ip_q1, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "ip_dotquad_2");
			itoa(ip_q2, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "ip_dotquad_3");
			itoa(ip_q3, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "ip_dotquad_4");
			itoa(ip_q4, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
	
			nm_q1 = buffer[6];
			nm_q2 = buffer[7];
			nm_q3 = buffer[8];
			nm_q4 = buffer[9];
			currentwidget = lookup_widget (ipchangewindow, "netmask_dotquad_1");
			itoa(nm_q1, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "netmask_dotquad_2");
			itoa(nm_q2, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "netmask_dotquad_3");
			itoa(nm_q3, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "netmask_dotquad_4");
			itoa(nm_q4, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
	
			gw_q1 = buffer[10];
			gw_q2 = buffer[11];
			gw_q3 = buffer[12];
			gw_q4 = buffer[13];
			currentwidget = lookup_widget (ipchangewindow, "gateway_dotquad_1");
			itoa(gw_q1, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "gateway_dotquad_2");
			itoa(gw_q2, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "gateway_dotquad_3");
			itoa(gw_q3, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
			currentwidget = lookup_widget (ipchangewindow, "gateway_dotquad_4");
			itoa(gw_q4, temp_buffer);
			gtk_entry_set_text (currentwidget, temp_buffer);
		}

		if (recd_number_array[0]==4) {		// SysID frame received
			i=0;
			while(buffer[i+2] != 0) {
				temp_buffer[i] = buffer[i+2];
				i++;
			}
			temp_buffer[i]=0;
			currentwidget = lookup_widget (main_window, "sysid");
			gtk_label_set_text (currentwidget, temp_buffer);
		}
	
		if (strstr(buffer, "OK") != NULL) {
			// The OK command was received--send for new data again
			// Or, if I wanted to send something else, as it must be sent from this
			// point in the code for the synchronous communication protocol to function
			// properly, send it here instead
			if (sending_frame == 0) {
				if (want_to_grab_something[0] == 0) {
					write(clientSocket, "TR\n\r", 4);		// Ask for status
				}
				else {
					write(clientSocket, want_to_grab_something, 4);
					want_to_grab_something[0] = 0;
					frame_requested = frame_requested_request;
				}
			}
			last_command_acked = 0;
			data_goahead = 1;
		}
	}
	else {
		i = 0;
		// Frame requested!
		if (frame_requested == 1) {
			j=480;
		}
		else if (frame_requested == 2) {
			j=245;
		}
		else {
			j=0;
		}
		while (j>0) {
			// Display the received image line
			while (x<640) {
				if (frame_requested == 1) {
					put_pixel(imagebuffer, x, y, temp_buffer[(i*4)+1], temp_buffer[(i*4)+2], temp_buffer[(i*4)+3], 255);
				}
				if (frame_requested == 2) {
					put_pixel(hiddenbuffer, x, y, temp_buffer[(i*4)+1], temp_buffer[(i*4)+2], temp_buffer[(i*4)+3], temp_buffer[(i*4)+0]);
				}
				i++;
				x++;
			}
			x=0;
			y++;
			j--;
		}
DoneWithFrameDataChunk:
		if (frame_requested == 1) {
			imagebox = lookup_widget (main_window, "imagebox");
			gtk_image_set_from_pixbuf(imagebox, imagebuffer);
		}
		if (frame_requested == 2) {
			imagebox = lookup_widget (main_window, "imagebox");
			gtk_image_set_from_pixbuf(imagebox, hiddenbuffer);
		}

		if (frame_requested == 1) {
			frame_requested = 0;
  			EnableMainCommands();
		}
		if (frame_requested == 2) {
			frame_requested = 0;
			EnableMainCommands();
		}
		if (frame_requested == 0) {
			i = send_data("TR\n\r");
		}
	}
    }

    return !terminate_now;
}

int stop_connection(void) {
    execute_connection_alive_timer=0;		// Halt the connection alive timer
    close(clientSocket);
}

int send_data(char *STR) {
	write(clientSocket, STR, strlen(STR));
}

int send_ndata(char *STR, unsigned int length) {
	write(clientSocket, STR, length);
}

int connection_timer_check(void) {
	GtkWidget* nconnect;
	GtkWidget* nmonitor;

	if (disable_connection_alive_timer == 0) {
		connection_alive_timer++;
		if (connection_alive_timer > 100) {
			connection_alive_timer = 0;
			// One second has gone by with no response...
			if (authenticated == 0) {
				authentication_failed_timer++;
			}
			if (authenticated == 1) {
				connection_failed_timer++;
				currentwidget = lookup_widget (main_window, "retry_progress");
				gtk_progress_configure(currentwidget, connection_failed_timer,0,6);
				if (connection_failed_timer > 5) {
					connection_failed_timer = 0;
					if (frame_requested == 0) {
						write(clientSocket, "TR\n\r", 4);
						last_command_acked = 0;
					}
					else {
						write(clientSocket, "GF\n\r", 4);
					}
					gtk_progress_configure(currentwidget,0,0,6);
					connection_irrecoverable_timer++;
					if (connection_irrecoverable_timer > 1) {
						// Board seems to have died.  DISCONNECT
						nconnect = lookup_widget (main_window, "nconnect");
						DisableMainCommands();
						nmonitor = lookup_widget (main_window, "nmonitor");
						gtk_widget_set_sensitive(nmonitor, 0);
						gtk_widget_set_sensitive(nconnect, 1);
						stop_connection();
					}
				}
			}
		}
	}

	return execute_connection_alive_timer;
}